diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/core/model/type-id.h ns-3.44/src/core/model/type-id.h
--- ns-3.43/src/core/model/type-id.h	2024-10-09 16:41:09.864655700 -0700
+++ ns-3.44/src/core/model/type-id.h	2025-03-09 16:55:49.363371100 -0700
@@ -12,6 +12,7 @@
 #include "attribute-helper.h"
 #include "attribute.h"
 #include "callback.h"
+#include "deprecated.h"
 #include "hash.h"
 #include "trace-source-accessor.h"
 
@@ -19,8 +20,8 @@
 #include <string>
 
 /**
- * \file
- * \ingroup object
+ * @file
+ * @ingroup object
  * ns3::TypeId declaration; inline and template implementations.
  */
 
@@ -30,8 +31,8 @@
 class ObjectBase;
 
 /**
- * \ingroup object
- * \brief a unique identifier for an interface.
+ * @ingroup object
+ * @brief a unique identifier for an interface.
  *
  * This class records a lot of meta-information about a
  * subclass of the Object base class:
@@ -39,9 +40,9 @@
  *  - the set of accessible constructors in the subclass
  *  - the set of 'attributes' accessible in the subclass
  *
- * \see attribute_TypeId
+ * @see attribute_TypeId
  *
- * \internal
+ * @internal
  *  See the discussion in IidManager about hash chaining of TypeId's.
  */
 class TypeId
@@ -58,13 +59,28 @@
     };
 
     /** The level of support or deprecation for attributes or trace sources. */
-    enum SupportLevel
+    enum class SupportLevel
     {
         SUPPORTED,  /**< Attribute or trace source is currently used. */
         DEPRECATED, /**< Attribute or trace source is deprecated; user is warned. */
         OBSOLETE    /**< Attribute or trace source is not used anymore; simulation fails. */
     };
 
+    /**
+     * Deprecated support level simple enums.
+     *
+     * Use the `TypeId::SupportLevel` enum class symbols instead.
+     * @{
+     */
+    NS_DEPRECATED_3_44("Use SupportLevel::SUPPORTED instead")
+    static constexpr auto SUPPORTED = SupportLevel::SUPPORTED;
+    NS_DEPRECATED_3_44("Use SupportLevel::DEPRECATED instead")
+    static constexpr auto DEPRECATED = SupportLevel::DEPRECATED;
+    NS_DEPRECATED_3_44("Use SupportLevel::OBSOLETE instead")
+    static constexpr auto OBSOLETE = SupportLevel::OBSOLETE;
+
+    /**@}*/
+
     /** Attribute implementation. */
     struct AttributeInformation
     {
@@ -111,8 +127,8 @@
     /**
      * Get a TypeId by name.
      *
-     * \param [in] name The name of the requested TypeId
-     * \returns The unique id associated with the requested name.
+     * @param [in] name The name of the requested TypeId
+     * @returns The unique id associated with the requested name.
      *
      * This method cannot fail: it will crash if the input
      * name is not a valid TypeId name.
@@ -121,17 +137,17 @@
     /**
      * Get a TypeId by name.
      *
-     * \param [in]  name The name of the requested TypeId
-     * \param [out] tid A pointer to the TypeId instance where the
+     * @param [in]  name The name of the requested TypeId
+     * @param [out] tid A pointer to the TypeId instance where the
      *              result of this function should be stored.
-     * \returns \c true if the requested name was found.
+     * @returns \c true if the requested name was found.
      */
     static bool LookupByNameFailSafe(std::string name, TypeId* tid);
     /**
      * Get a TypeId by hash.
      *
-     * \param [in] hash The hash to lookup
-     * \returns The unique id associated with the requested hash.
+     * @param [in] hash The hash to lookup
+     * @returns The unique id associated with the requested hash.
      *
      * This method cannot fail: it will crash if the input
      * hash does not match an existing TypeId.
@@ -140,31 +156,31 @@
     /**
      * Get a TypeId by hash.
      *
-     * \param [in]  hash The hash of the requested TypeId
-     * \param [out] tid A pointer to the TypeId instance where the
+     * @param [in]  hash The hash of the requested TypeId
+     * @param [out] tid A pointer to the TypeId instance where the
      *              result of this function should be stored.
-     * \returns \c true if the requested hash was found.
+     * @returns \c true if the requested hash was found.
      */
     static bool LookupByHashFailSafe(hash_t hash, TypeId* tid);
 
     /**
      * Get the number of registered TypeIds.
      *
-     * \returns The number of TypeId instances registered.
+     * @returns The number of TypeId instances registered.
      */
     static uint16_t GetRegisteredN();
     /**
      * Get a TypeId by index.
      *
-     * \param [in] i Index of the TypeId.
-     * \returns The TypeId instance whose index is \c i.
+     * @param [in] i Index of the TypeId.
+     * @returns The TypeId instance whose index is \c i.
      */
     static TypeId GetRegistered(uint16_t i);
 
     /**
      * Constructor.
      *
-     * \param [in] name The name of the interface to construct.
+     * @param [in] name The name of the interface to construct.
      *
      * No two instances can share the same name. The name is expected to be
      * the full c++ typename of associated c++ object.
@@ -174,8 +190,8 @@
     /**
      * Add an deprecated name for a TypeId.
      *
-     * \param [in] name The deprecated name.
-     * \return This TypeId instance.
+     * @param [in] name The deprecated name.
+     * @return This TypeId instance.
      *
      * To allow for deprecations (such as moving a TypeId into a namespace
      * but wishing to preserve the original string from namespace ns3),
@@ -188,7 +204,7 @@
     /**
      * Get the parent of this TypeId.
      *
-     * \returns The parent of this TypeId
+     * @returns The parent of this TypeId
      *
      * This method cannot fail. It will return itself
      * if this TypeId has no parent. i.e., it is at the top
@@ -201,15 +217,15 @@
     /**
      * Check if this TypeId has a parent.
      *
-     * \return \c true if this TypeId has a parent.
+     * @return \c true if this TypeId has a parent.
      */
     bool HasParent() const;
 
     /**
      * Check if this TypeId is a child of another.
      *
-     * \param [in] other A parent TypeId
-     * \returns \c true if the input TypeId is really a parent of this TypeId.
+     * @param [in] other A parent TypeId
+     * @returns \c true if the input TypeId is really a parent of this TypeId.
      *
      * Calling this method is roughly similar to calling dynamic_cast
      * except that you do not need object instances: you can do the check
@@ -220,63 +236,63 @@
     /**
      * Get the group name.
      *
-     * \returns The name of the group associated to this TypeId.
+     * @returns The name of the group associated to this TypeId.
      */
     std::string GetGroupName() const;
 
     /**
      * Get the name.
      *
-     * \returns The name of this interface.
+     * @returns The name of this interface.
      */
     std::string GetName() const;
 
     /**
      * Get the hash.
      *
-     * \returns The hash of this interface.
+     * @returns The hash of this interface.
      */
     hash_t GetHash() const;
 
     /**
      * Get the size of this object.
      *
-     * \returns The size of this interface.
+     * @returns The size of this interface.
      */
     std::size_t GetSize() const;
 
     /**
      * Check if this TypeId has a constructor.
      *
-     * \returns \c true if this TypeId has a constructor
+     * @returns \c true if this TypeId has a constructor
      */
     bool HasConstructor() const;
 
     /**
      * Get the number of attributes.
      *
-     * \returns The number of attributes associated to this TypeId
+     * @returns The number of attributes associated to this TypeId
      */
     std::size_t GetAttributeN() const;
     /**
      * Get Attribute information by index.
      *
-     * \param [in] i Index into attribute array
-     * \returns The information associated to attribute whose index is \pname{i}.
+     * @param [in] i Index into attribute array
+     * @returns The information associated to attribute whose index is \pname{i}.
      */
     TypeId::AttributeInformation GetAttribute(std::size_t i) const;
     /**
      * Get the Attribute name by index.
      *
-     * \param [in] i Index into attribute array
-     * \returns The full name associated to the attribute whose index is \pname{i}.
+     * @param [in] i Index into attribute array
+     * @returns The full name associated to the attribute whose index is \pname{i}.
      */
     std::string GetAttributeFullName(std::size_t i) const;
 
     /**
      * Get the constructor callback.
      *
-     * \returns A callback which can be used to instantiate an object
+     * @returns A callback which can be used to instantiate an object
      *          of this type.
      */
     Callback<ObjectBase*> GetConstructor() const;
@@ -284,29 +300,29 @@
     /**
      * Check if this TypeId should not be listed in documentation.
      *
-     * \returns \c true if this TypeId should be hidden from the user.
+     * @returns \c true if this TypeId should be hidden from the user.
      */
     bool MustHideFromDocumentation() const;
 
     /**
      * Get the number of Trace sources.
      *
-     * \returns The number of trace sources defined in this TypeId.
+     * @returns The number of trace sources defined in this TypeId.
      */
     std::size_t GetTraceSourceN() const;
     /**
      * Get the trace source by index.
      *
-     * \param [in] i Index into trace source array.
-     * \returns Detailed information about the requested trace source.
+     * @param [in] i Index into trace source array.
+     * @returns Detailed information about the requested trace source.
      */
     TypeId::TraceSourceInformation GetTraceSource(std::size_t i) const;
 
     /**
      * Set the parent TypeId.
      *
-     * \param [in] tid The TypeId of the base class.
-     * \return This TypeId instance.
+     * @param [in] tid The TypeId of the base class.
+     * @return This TypeId instance.
      *
      * Record in this TypeId which TypeId is the TypeId
      * of the base class of the subclass.
@@ -315,8 +331,8 @@
     /**
      * Set the parent TypeId.
      *
-     * \tparam T \explicit The parent TypeID type.
-     * \return This TypeId instance.
+     * @tparam T \explicit The parent TypeID type.
+     * @return This TypeId instance.
      *
      * Record in this TypeId which TypeId is the TypeId
      * of the base class of the subclass.
@@ -327,8 +343,8 @@
     /**
      * Set the group name.
      *
-     * \param [in] groupName The name of the group this TypeId belongs to.
-     * \returns This TypeId instance.
+     * @param [in] groupName The name of the group this TypeId belongs to.
+     * @returns This TypeId instance.
      *
      * The group name is purely an advisory information used to
      * group together types according to a user-specific grouping
@@ -340,15 +356,15 @@
      * Set the size of this type.
      *
      * Call this way:
-     * \code
+     * @code
      *   SetSize (sizeof (<typename>));
-     * \endcode
+     * @endcode
      * This is done automatically by NS_LOG_ENSURE_REGISTERED()
      * A ridiculously large reported size is a symptom that the
      * type hasn't been registered.
      *
-     * \param [in] size The size of the object, in bytes.
-     * \returns This TypeId instance.
+     * @param [in] size The size of the object, in bytes.
+     * @returns This TypeId instance.
      */
     TypeId SetSize(std::size_t size);
 
@@ -356,8 +372,8 @@
      * Record in this TypeId the fact that the default constructor
      * is accessible.
      *
-     * \tparam T \explicit The class name represented by this TypeId.
-     * \returns This TypeId instance
+     * @tparam T \explicit The class name represented by this TypeId.
+     * @returns This TypeId instance
      */
     template <typename T>
     TypeId AddConstructor();
@@ -365,16 +381,16 @@
     /**
      * Record in this TypeId the fact that a new attribute exists.
      *
-     * \param [in] name The name of the new attribute
-     * \param [in] help Some help text which describes the purpose of this
+     * @param [in] name The name of the new attribute
+     * @param [in] help Some help text which describes the purpose of this
      *             attribute.
-     * \param [in] initialValue The initial value for this attribute.
-     * \param [in] accessor An instance of the associated AttributeAccessor
+     * @param [in] initialValue The initial value for this attribute.
+     * @param [in] accessor An instance of the associated AttributeAccessor
      *             subclass.
-     * \param [in] checker An instance of the associated AttributeChecker
+     * @param [in] checker An instance of the associated AttributeChecker
      *             subclass.
-     * \param [in] supportLevel Support/deprecation status of the attribute.
-     * \param [in] supportMsg Upgrade hint if this attribute is no longer
+     * @param [in] supportLevel Support/deprecation status of the attribute.
+     * @param [in] supportMsg Upgrade hint if this attribute is no longer
      *             supported.  If the attribute is \c DEPRECATED the attribute
      *             behavior still exists, but user code should be updated
      *             following guidance in the hint.
@@ -382,46 +398,46 @@
      *             which class the attribute functional has been moved to,
      *             or that the functionality is no longer supported.
      *             See test file type-id-test-suite.cc for examples.
-     * \returns This TypeId instance
+     * @returns This TypeId instance
      */
     TypeId AddAttribute(std::string name,
                         std::string help,
                         const AttributeValue& initialValue,
                         Ptr<const AttributeAccessor> accessor,
                         Ptr<const AttributeChecker> checker,
-                        SupportLevel supportLevel = SUPPORTED,
+                        SupportLevel supportLevel = SupportLevel::SUPPORTED,
                         const std::string& supportMsg = "");
 
     /**
      * Set the initial value of an Attribute.
      *
-     * \param [in] i The attribute to manipulate
-     * \param [in] initialValue The new initial value to use for this attribute.
-     * \returns \c true if the call was successfully.
+     * @param [in] i The attribute to manipulate
+     * @param [in] initialValue The new initial value to use for this attribute.
+     * @returns \c true if the call was successfully.
      */
     bool SetAttributeInitialValue(std::size_t i, Ptr<const AttributeValue> initialValue);
 
     /**
      * Record in this TypeId the fact that a new attribute exists.
      *
-     * \param [in] name The name of the new attribute
-     * \param [in] help Some help text which describes the purpose of this
+     * @param [in] name The name of the new attribute
+     * @param [in] help Some help text which describes the purpose of this
      *        attribute
-     * \param [in] flags Flags which describe how this attribute can be read and/or written.
-     * \param [in] initialValue The initial value for this attribute.
-     * \param [in] accessor An instance of the associated AttributeAccessor
+     * @param [in] flags Flags which describe how this attribute can be read and/or written.
+     * @param [in] initialValue The initial value for this attribute.
+     * @param [in] accessor An instance of the associated AttributeAccessor
      *             subclass.
-     * \param [in] checker An instance of the associated AttributeChecker
+     * @param [in] checker An instance of the associated AttributeChecker
      *             subclass.
-     * \param [in] supportLevel Support/deprecation status of the attribute.
-     * \param [in] supportMsg Upgrade hint if this attribute is no longer
+     * @param [in] supportLevel Support/deprecation status of the attribute.
+     * @param [in] supportMsg Upgrade hint if this attribute is no longer
      *             supported.  If the attribute is \c DEPRECATED the attribute
      *             behavior still exists, but user code should be updated
      *             following guidance in the hint..
      *             If the attribute is \c OBSOLETE, the hint should indicate
      *             which class the attribute functional has been moved to,
      *             or that the functionality is no longer supported.
-     * \returns This TypeId instance
+     * @returns This TypeId instance
      */
     TypeId AddAttribute(std::string name,
                         std::string help,
@@ -429,22 +445,22 @@
                         const AttributeValue& initialValue,
                         Ptr<const AttributeAccessor> accessor,
                         Ptr<const AttributeChecker> checker,
-                        SupportLevel supportLevel = SUPPORTED,
+                        SupportLevel supportLevel = SupportLevel::SUPPORTED,
                         const std::string& supportMsg = "");
 
     /**
      * Record a new TraceSource.
      *
-     * \param [in] name The name of the new trace source
-     * \param [in] help Some help text which describes the purpose of this
+     * @param [in] name The name of the new trace source
+     * @param [in] help Some help text which describes the purpose of this
      *             trace source.
-     * \param [in] accessor A pointer to a TraceSourceAccessor which can be
+     * @param [in] accessor A pointer to a TraceSourceAccessor which can be
      *             used to connect/disconnect sinks to this trace source.
-     * \param [in] callback Fully qualified typedef name for the callback
+     * @param [in] callback Fully qualified typedef name for the callback
      *             signature.  Generally this should begin with the
      *             "ns3::" namespace qualifier.
-     * \param [in] supportLevel Support/deprecation status of the attribute.
-     * \param [in] supportMsg Upgrade hint if this attribute is no longer
+     * @param [in] supportLevel Support/deprecation status of the attribute.
+     * @param [in] supportMsg Upgrade hint if this attribute is no longer
      *             supported.  If the attribute is \c DEPRECATED the attribute
      *             behavior still exists, but user code should be updated
      *             following guidance in the hint..
@@ -452,27 +468,27 @@
      *             which class the attribute functional has been moved to,
      *             or that the functionality is no longer supported.
      *             See test file type-id-test-suite.cc for examples.
-     * \returns This TypeId instance.
+     * @returns This TypeId instance.
      */
     TypeId AddTraceSource(std::string name,
                           std::string help,
                           Ptr<const TraceSourceAccessor> accessor,
                           std::string callback,
-                          SupportLevel supportLevel = SUPPORTED,
+                          SupportLevel supportLevel = SupportLevel::SUPPORTED,
                           const std::string& supportMsg = "");
 
     /**
      * Hide this TypeId from documentation.
-     * \returns This TypeId instance.
+     * @returns This TypeId instance.
      */
     TypeId HideFromDocumentation();
 
     /**
      * Find an attribute by name in the inheritance tree for a given TypeId.
      *
-     * \param [in] tid The TypeId to start the search from.
-     * \param [in] name The name of the attribute to search for.
-     * \return A tuple containing a boolean that indicates whether the attribute was found, the
+     * @param [in] tid The TypeId to start the search from.
+     * @param [in] name The name of the attribute to search for.
+     * @return A tuple containing a boolean that indicates whether the attribute was found, the
      * TypeId where the attribute was found, and the AttributeInformation of the found attribute.
      */
     static std::tuple<bool, TypeId, AttributeInformation> FindAttribute(const TypeId& tid,
@@ -481,14 +497,14 @@
     /**
      * Find an Attribute by name, retrieving the associated AttributeInformation.
      *
-     * \param [in]  name The name of the requested attribute
-     * \param [in,out] info A pointer to the TypeId::AttributeInformation
+     * @param [in]  name The name of the requested attribute
+     * @param [in,out] info A pointer to the TypeId::AttributeInformation
      *              data structure where the result value of this method
      *              will be stored.
-     * \param [in] permissive If false (by default), will generate warnings and errors for
+     * @param [in] permissive If false (by default), will generate warnings and errors for
      * deprecated and obsolete attributes, respectively. If set to true, warnings for deprecated
      * attributes will be suppressed.
-     * \returns \c true if the requested attribute could be found.
+     * @returns \c true if the requested attribute could be found.
      */
     bool LookupAttributeByName(std::string name,
                                AttributeInformation* info,
@@ -498,8 +514,8 @@
      *
      * If no matching trace source is found, this method returns zero.
      *
-     * \param [in] name The name of the requested trace source
-     * \return The trace source accessor which can be used to connect
+     * @param [in] name The name of the requested trace source
+     * @return The trace source accessor which can be used to connect
      *  and disconnect trace sinks with the requested trace source on
      *  an object instance.
      */
@@ -507,11 +523,11 @@
     /**
      * Find a TraceSource by name, retrieving the associated TraceSourceInformation.
      *
-     * \param [in]  name The name of the requested trace source.
-     * \param [out] info A pointer to the TypeId::TraceSourceInformation
+     * @param [in]  name The name of the requested trace source.
+     * @param [out] info A pointer to the TypeId::TraceSourceInformation
      *              data structure where the result value of this method
      *              will be stored.
-     * \return The trace source accessor which can be used to connect
+     * @return The trace source accessor which can be used to connect
      *  and disconnect trace sinks with the requested trace source on
      *  an object instance.
      */
@@ -521,7 +537,7 @@
     /**
      * Get the internal id of this TypeId.
      *
-     * \returns The internal integer which uniquely identifies this TypeId.
+     * @returns The internal integer which uniquely identifies this TypeId.
      *
      * This is really an internal method which users are not expected
      * to use.
@@ -530,7 +546,7 @@
     /**
      * Set the internal id of this TypeId.
      *
-     * \param [in] uid The internal integer which uniquely identifies
+     * @param [in] uid The internal integer which uniquely identifies
      *            this TypeId.  This TypeId should already have been registered.
      *
      * Typically this is used in serialization/deserialization.
@@ -545,13 +561,13 @@
     inline TypeId();
     /**
      * Copy constructor.
-     * \param [in] o The other TypeId.
+     * @param [in] o The other TypeId.
      */
     inline TypeId(const TypeId& o);
     /**
      * Assignment.
-     * \param [in] o The other TypeId.
-     * \returns The copied TypeId.
+     * @param [in] o The other TypeId.
+     * @returns The copied TypeId.
      */
     inline TypeId& operator=(const TypeId& o);
     /** Destructor. */
@@ -559,7 +575,7 @@
 
   private:
     /**
-     * \name Comparison operators.
+     * @name Comparison operators.
      * Standard comparison operators.
      * @{
      */
@@ -570,13 +586,13 @@
 
     /**
      * Construct from an integer value.
-     * \param [in] tid The TypeId value as an integer.
+     * @param [in] tid The TypeId value as an integer.
      */
     explicit TypeId(uint16_t tid);
     /**
      * Implementation for AddConstructor().
      *
-     * \param [in] callback Callback which constructs an instance of this TypeId.
+     * @param [in] callback Callback which constructs an instance of this TypeId.
      */
     void DoAddConstructor(Callback<ObjectBase*> callback);
 
@@ -585,28 +601,36 @@
 };
 
 /**
- * \relates TypeId
+ * @relates TypeId
  * Output streamer.
  *
- * \param [in,out] os The output stream.
- * \param [in] tid The TypeId.
- * \returns The output stream.
+ * @param [in,out] os The output stream.
+ * @param [in] tid The TypeId.
+ * @returns The output stream.
  */
 std::ostream& operator<<(std::ostream& os, TypeId tid);
 /**
- * \relates TypeId
+ * @relates TypeId
  * Input Streamer.
- * \param [in,out] is The input stream.
- * \param [out] tid The TypeId to set from the stream.
- * \returns The input stream.
+ * @param [in,out] is The input stream.
+ * @param [out] tid The TypeId to set from the stream.
+ * @returns The input stream.
  */
 std::istream& operator>>(std::istream& is, TypeId& tid);
 
 /**
+ * @brief Stream insertion operator.
+ * @param [in] os The reference to the output stream.
+ * @param [in] level The TypeId::SupportLevel.
+ * @return The reference to the output stream.
+ */
+std::ostream& operator<<(std::ostream& os, TypeId::SupportLevel level);
+
+/**
  * Comparison operator.
- * \param [in] a One value.
- * \param [in] b The other value.
- * \returns The result of the comparison.
+ * @param [in] a One value.
+ * @param [in] b The other value.
+ * @returns The result of the comparison.
  * @{
  */
 inline bool operator==(TypeId a, TypeId b);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/core/model/type-name.h ns-3.44/src/core/model/type-name.h
--- ns-3.43/src/core/model/type-name.h	2024-10-09 16:41:09.864655700 -0700
+++ ns-3.44/src/core/model/type-name.h	2025-03-09 16:55:49.363371100 -0700
@@ -13,8 +13,8 @@
 #include <string>
 
 /**
- * \file
- * \ingroup attributeimpl
+ * @file
+ * @ingroup attributeimpl
  * ns3::TypeNameGet() function declarations.
  */
 
@@ -22,14 +22,14 @@
 {
 
 /**
- * \ingroup attributeimpl
+ * @ingroup attributeimpl
  *
  * Type name strings for AttributeValue types.
  * Custom classes should add a template specialization of this function
  * using the macro \c TYPENAMEGET_DEFINE(T).
  *
- * \tparam T \explicit The type.
- * \returns The type name as a string.
+ * @tparam T \explicit The type.
+ * @returns The type name as a string.
  */
 template <typename T>
 std::string
@@ -40,11 +40,11 @@
 }
 
 /**
- * \ingroup attributeimpl
+ * @ingroup attributeimpl
  *
  * Macro that defines a template specialization for \c TypeNameGet<T>() .
  *
- * \param T The type.
+ * @param T The type.
  */
 #define TYPENAMEGET_DEFINE(T)                                                                      \
     template <>                                                                                    \
@@ -54,9 +54,9 @@
     }
 
 /**
- * \ingroup attributeimpl
+ * @ingroup attributeimpl
  * ns3::TypeNameGet() specialization for numeric types.
- * \returns The numeric type name as a string.
+ * @returns The numeric type name as a string.
  * @{
  */
 TYPENAMEGET_DEFINE(bool);
